'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.isQuery = isQuery;
exports.getListFunction = getListFunction;
exports.getListParams = getListParams;
exports.createListAction = createListAction;
exports.createMapStateToPropsList = createMapStateToPropsList;
exports.connectList = connectList;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _utils = require('../../utils');

var utils = _interopRequireWildcard(_utils);

var _common = require('./common');

var createMapStateToProps = function createMapStateToProps(mountPoint, folder, propName) {
  if (folder === undefined) folder = '';
  return function mapStateToPropsList(state) {
    var _ref2;

    if (!utils.hasFolder(state[mountPoint], folder)) {
      return _defineProperty({}, propName, null);
    }
    return _ref2 = {}, _defineProperty(_ref2, propName, utils.getDocumentsInFolder(state[mountPoint], folder)), _defineProperty(_ref2, 'folderVars', utils.getFolderVars(state[mountPoint], folder)), _ref2;
  };
};

exports.createMapStateToProps = createMapStateToProps;

function isQuery(opts) {
  return opts.options && opts.options.fun;
}

function getListFunction(crud, opts) {
  if (isQuery(opts)) {
    return crud.actions.query.bind(null, opts.options.fun);
  } else {
    return crud.actions.allDocs;
  }
}

function getListParams(crud, opts) {
  var initialParams = {};

  if (!isQuery(opts)) {
    Object.assign(initialParams, {
      startkey: crud.startkey,
      endkey: crud.endkey
    });
  }

  var params = _extends({
    include_docs: true,
    attachments: true
  }, initialParams, opts.options);

  return params;
}

function createListAction(crud, folder) {
  var opts = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
  var folderVars = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

  var funName = getListFunction(crud, opts);
  var funParams = getListParams(crud, opts);
  return funName(folder, funParams, folderVars);
}

function createMapStateToPropsList(crud, opts, mapStateToProps) {
  if (opts === undefined) opts = {};

  return function (state, ownProps) {
    var props = mapStateToProps ? mapStateToProps(state, ownProps) : {};
    var finalOpts = Object.assign({}, opts, props.listOpts);
    var _finalOpts$options = finalOpts.options;
    var options = _finalOpts$options === undefined ? {} : _finalOpts$options;
    var folder = finalOpts.folder;
    var _finalOpts$propName = finalOpts.propName;
    var propName = _finalOpts$propName === undefined ? 'items' : _finalOpts$propName;

    var folderVars = _objectWithoutProperties(finalOpts, ['options', 'folder', 'propName']);

    var toFolder = folder || (0, _utils.folderNameFromOpts)(options);

    Object.assign(props, createMapStateToProps(crud.mountPoint, toFolder, propName)(state));

    props.action = createListAction;
    props.actionArgs = [crud, toFolder, finalOpts, folderVars];
    return props;
  };
}

function connectList(crud, opts, mapStateToProps, mapDispatchToProps) {
  if (opts === undefined) opts = {};

  (0, _invariant2['default'])(typeof crud !== 'undefined', 'crud is required parameter');

  var mapStateToPropsFinal = createMapStateToPropsList(crud, opts, mapStateToProps);
  return (0, _common.wrap)(mapStateToPropsFinal, mapDispatchToProps);
}