'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = loading;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var isEqual = require('lodash.isequal');

var defaultOpts = {
  propName: 'items'
};

/**
 * loading decorator
 *
 * @param {function} loadFunction(component)
 * @param {object} [opts={}]
 * @param {string} [opts.propName='items']
 * @param {string} [opts.loadingText='loading....']
 * @param {string} [opts.action] action to dispatch if props[propName] is false
 * @returns {Component}
 */

function loading(loadFunction) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var options = Object.assign({}, defaultOpts, opts);

  return function loadingWithLoadFunction(ComposedComponent) {
    return (function (_Component) {
      _inherits(ComponentWithLoading, _Component);

      function ComponentWithLoading() {
        var _this = this;

        _classCallCheck(this, ComponentWithLoading);

        _get(Object.getPrototypeOf(ComponentWithLoading.prototype), 'constructor', this).apply(this, arguments);

        this.componentDidMount = function () {
          _this.loadIfNeeded(_this.props);
        };

        this.componentWillReceiveProps = function (nextProps) {
          if (_this.props.action == nextProps.action && isEqual(_this.props.actionArgs, nextProps.actionArgs)) {
            return;
          }
          _this.loadIfNeeded(nextProps);
        };
      }

      _createClass(ComponentWithLoading, [{
        key: 'getPropName',
        value: function getPropName() {
          return this.props.propName || options.propName;
        }
      }, {
        key: 'hasItems',
        value: function hasItems(props) {
          return props[this.getPropName()];
        }
      }, {
        key: 'getAction',
        value: function getAction() {
          return this.props.action || opts.action;
        }
      }, {
        key: 'getLoadFunction',
        value: function getLoadFunction() {
          return loadFunction;
        }
      }, {
        key: 'loadIfNeeded',
        value: function loadIfNeeded(props) {
          if (!this.hasItems(props)) {
            var action = this.getAction();
            if (action) {
              this.props.dispatch(action.apply(this, props.actionArgs));
            } else {
              this.getLoadFunction()(this);
            }
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var isLoading = !this.hasItems(this.props);
          return _react2['default'].createElement(ComposedComponent, _extends({}, this.props, {
            isLoading: isLoading
          }));
        }
      }]);

      return ComponentWithLoading;
    })(_react.Component);
  };
}

;
module.exports = exports['default'];